@ECHO OFF
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
::-mkhidGPT.cmd small batch by jaclaz to create a "hidden"
::-very small partition, FAT 12 formatted, to be deployed to sectors 63-2047
::-of a GPT partitioned disk to allow - together with some special MBR code
::-to boot a grub4dos on a BIOS computer from a GPT disk
::-version 0.01 Alpha 11 July 2015
::-Needed files:
::-dsfo.exe and dsfi.exe from the DSFOK toolkit.
::-mformat.exe, mmd.exe, mdir.exe and mcopy.exe from the Mtools (for Windows).
::-FAT12grldr.bss Pre-made bootsector to load grub4dos on FAT12 volume
::-HidGPT63.mbr special MBR to boot to the hidden volume
::-a decently recent grldr from grub4dos 0.4.5c or 0.4.6a
IF %1.==. GOTO :usage

:Paramloop
SET PhysDN=%1
IF NOT DEFINED PhysDN GOTO :ParamOK
::For some (minimal) safety reason, \\.\PhysicalDrive0 (first disk) is not selectable
::you will need to change line below to SET MinDisk=0
SET MinDisk=1
FOR /L %%A IN (%MinDisk%,1,9) DO IF %%A==%PhysDN% GOTO :ParamOK

SET PhysDN=
SET ImgName=%1
SHIFT
IF /I %2.==/wo. SET Switch=writeonly
GOTO :Paramloop



ECHO The Physicaldrive number was not provided or it is invalid: %PhysDN%
GOTO :Aborted

:ParamOK
SET Missing=0
FOR %%A IN (
mformat.exe
mmd.exe
mcopy.exe
dsfi.exe
dsfo.exe
) DO IF NOT EXIST %%A CALL :Missing
IF %missing% GTR 0 GOTO :Aborted


IF DEFINED Switch GOTO :%Switch%

::The default target image is set to "HiddenGPT.img", you can change this name below:
IF NOT DEFINED ImgName SET ImgName=HiddenGPT.img



::Set Parameters for mformat
::This is not really *needed* but it makes easier to understand the parameters
::should they need to be changed or for future re-use

::Total image size 1985 given as 2047-63+1
SET ImgSize=-T 1985
::Standard 255/63 geometry
SET HSGeom=-h 255 -s 63
::Fixed Volume Serial Number, just for the fun of it
SET VolSerial=-N 66537457
::Arbitrary Label Note: if you want a simple (not VFAT) label the name must be all CAPITAL letters
::this is seemingly non-standard as FAT12 Labels should be ALL CAPITALS anyway 
SET Label=-v G4D_BIOSGPT
::Sectors Before 63
SET SectBefore=-H 63
::Cluster size, 512 bytes size=1 sector size
SET ClustSize=-c 1
:: Size for Root directory in sectors, 1 equates to 16 entries that should be enough
SET RootSize=-r 1
::Number of fats, usually 2, here set to 1 to spare as much sectors as possible
SET NumFats=-d 1
::Bootsector, the "standard" FAT12 bootsector, here with drive number pre-set to 80 because Mformat misses a way to set it
SET Bootsector=-B FAT12grldr.bss
::Media Type F8, hard disk volume
SET Mediatype=-m F8
::Target image
SET Target=-i %ImgName%

::Senseless But Sometimes Needed Double Colon, which means "the drive which is mapped from the image specified with -i"
SET SBSNDC=::

::SET path to Mtools.ini as an environment variable
::This is needed to have mdir work as expected
SET MTOOLSRC=Mtools.ini
IF NOT EXIST Mtools.ini ECHO MTOOLS_SKIP_CHECK=1 >Mtools.ini


::Run the actual format to Create the target image
mformat -C %ImgSize% %HSGeom% %Label% %SectBefore% %ClustSize% %RootSize% %NumFats% %Bootsector% %Mediatype% %VolSerial% %Target% %SBSNDC%

::create the same directory structure as the contents of the \root subdirectory ("root" being the name of a subdir of where the batch is)
::use some of the usual common sense, don't use paths with spaces, strange characters, stupidly long filenames/paths, etc.
::in theory using the mcopy with the -s switch (recursive) should need not these loops, but I cannot make it work in practice
SET SubDir=root



IF NOT EXIST %~dp0%SubDir% ECHO Nothing to copy, an empty image was created...&GOTO :Aborted

FOR /F "delims=" %%A IN ('DIR %~dp0%SubDir% /A:D /B /S') DO (
SET Reldir=%%A
SET Reldir=!Reldir:%~dp0%SubDir%\=!
SET Reldir=!Reldir:\=/!
ECHO mmd "!Reldir!" %Target%
mmd "!Reldir!" %Target%
)

FOR /F "delims=" %%A IN ('DIR %~dp0%SubDir% /A:-D /B /S') DO (
SET Relfile=%%A
SET Relfile=!Relfile:%~dp0%SubDir%\=!
SET Relfile=!Relfile:\=/!
ECHO mcopy "./root/!Relfile!" %Target% "%SBSNDC%!Relfile!"
mcopy "./root/!Relfile!" %Target% "%SBSNDC%!Relfile!"
)

mdir -/ %Target% |FIND /V "<DIR>" |FIND /V " files"
IF %ERRORLEVEL%==1 ECHO Oh, oh, an error occurred, no files in the image ...&GOTO :Aborted
IF NOT DEFINED PhysDN PAUSE&GOTO :EOF

:writeonly
SET Confirm=No
IF NOT EXIST %ImgName% CALL :Missing %ImgName%&GOTO :EOF
ECHO Do you really want to write the image %ImgName%
ECHO to sectors 63-2047 of PhysicalDrive%PhysDN%?
SET /P Confirm=Type YES to confirm, press [ENTER] to abort 
IF /I NOT %Confirm%==YES GOTO :Aborted
ECHO Writing the image ...
dsfi \\.\Physicaldrive%PhysDN% 32256 1016320 %ImgName%
ECHO.
ECHO Writing the special MBR ...
IF NOT EXIST HidGPT63.mbr CALL :Missing HidGPT63.mbr&GOTO :EOF
IF EXIST GPTMBR.mbr DEL GPTMBR.mbr
dsfo \\.\Physicaldrive%PhysDN% 0 512 GPTMBR.mbr
dsfi GPTMBR.mbr 0 432 HidGPT63.mbr
dsfi \\.\Physicaldrive%PhysDN% 0 512 GPTMBR.mbr
GOTO :EOF

:usage
::-
::-Usage:
::-mkhidGPT.cmd <Image Name> [<Physicaldrive number>] [/wo]
::-PhysicalDrive number represents the number of Disk as seen is Disk Manager
::-or Diskpart. You will be however prompted for confirmation before writing 
::-the image to disk and writing to it the "special" MBR code.
::-mkhidGPT.cmd myimage.img <- will ONLY create the image
::-mkhidGPT.cmd myimage.img 1 <- will create the image AND write it to disk 1
::-mkhidGPT.cmd myimage.img 1 /wo <- will ONLY write the image to disk 1
::-Adding the /wo switch implies that the image already exists

TYPE %~dpnx0 | FIND "::-" |FIND /v "FIND"
PAUSE
GOTO :EOF

:Aborted
ECHO Batch aborted ...
PAUSE
GOTO :EOF

:Missing
SET /A Missing+=1
ECHO Needed file %1 is missing ....
PAUSE
GOTO :EOF
